module DS18B20Display
	(
		Clk,
		Rst,
     	DQ,   //18B20数据端口
		Txd,  //串口发送端口
		SMData, //数码管段码
		SMCom   //数码管位码
	);
input Rst,Clk;
output Txd;
inout DQ;
output[7:0] SMData;
output[3:0] SMCom;

wire DataReady;//测温完成信号
wire [15:0] MeasureResult;//DS18B20测温结果
reg  [15:0] Temperature;



//产生数码管的位码和段码
SMDisplay Gen_SM(.Rst(Rst),.Clk(Clk),.Data16bIn(Temperature),.SMData(SMData),.SMCom(SMCom));
//DS18B20测温和发送  
DS18B20 TmpMeasureAndTx(.Rst(Rst),.Clk(Clk),.DQ(DQ),.Txd(Txd),.FinishFlag(DataReady),.Data16b(MeasureResult));


always @ (posedge Clk or negedge Rst)
begin
	if (Rst==1'b0)
		Temperature<=16'H0000;
	else
		begin
			if (DataReady==1'b1)
				Temperature<=MeasureResult;
		end
end

endmodule