//偶数分频器，外部带入两个参数决定分频系数。默认是2分频
//divdFACTOR--分频系数，实际分频数为divdFACTOR*2
//divdWIDTH--分频计数器的位宽，实际位宽为divdWIDTH+1,该位宽所能表达的最大值>divdFACTOR
module gen_divd(reset,clkin,clkout);
	input reset,clkin;
	output clkout;
	parameter divdWIDTH=1;//分频计数器的位宽，实际位宽为divdWIDTH+1,该位宽所能表达的最大值>divdFACTOR
	parameter divdFACTOR=1;//分频系数是divdFACTOR*2
	reg clkout;
	reg [divdWIDTH:0] cnt;
	
	
	always @ (posedge reset or posedge clkin)
		if(reset)
			begin
			cnt<=0;
			clkout<=0;
			end
		else
			begin
			cnt<=cnt+1'b1;
			if(cnt==(divdFACTOR-1))
				begin
				cnt<=0;
				clkout<=~clkout;
				end 
			end
endmodule