//串口发送
module uart_x
	(
		Bclk,
		Resett,
		Txd,
		XmitCmdp,//由高变低以后的下一个时钟上升沿开始串口发送
		TxdBuf,
		TxDone
		//test
		/*
		BitCnt,
		nState,
		cState
		*/
	);
	input Bclk,Resett,XmitCmdp;
	input [7:0] TxdBuf;
	output Txd,TxDone;
	//test
	/*
	output [3:0] BitCnt;
	output [4:0] nState,cState;
	*/
	reg Txd,TxDone;
	reg [7:0] TxdBufTmp;
	parameter 	TXIdle=5'b0_0000,
				TXLode=5'b0_0001,
				TXStartBit=5'b0_0010,
				TXDataBit=5'b0_0100,
				TXStopBit=5'b0_1000,
				TXDone=5'b1_0000;
	reg [3:0] BitCnt;
	reg [4:0] nState,cState;
	
	//同步时序描述状态转移
	always @ (posedge Resett or posedge Bclk)
		if(Resett)
			cState<=TXIdle;
		else
			cState<=nState;
	//组合逻辑描述状态的转移条件	
	always @ (cState or XmitCmdp or Resett or BitCnt)
		if(Resett)
			nState=TXIdle;
		else if(XmitCmdp)
			nState=TXLode;
		else
			case(cState)
				TXLode:nState=TXStartBit;
				TXStartBit:nState=TXDataBit;
				TXDataBit:
						if(BitCnt>=8)
							nState=TXStopBit; 
						else
							nState=TXDataBit;
				TXStopBit:nState=TXDone;
				TXDone,TXIdle:nState=TXIdle;
				default:nState=5'bx;
			endcase
	//时序逻辑描述输出变化	
	always @(posedge Bclk or posedge Resett)
		if(Resett)
		begin
			Txd<=1'b1;
			TxDone<=1'b0;
			BitCnt<=4'b0000;
		end
		else
			case(nState)
				TXLode:
					begin
					TxdBufTmp<=TxdBuf;
					TxDone<=1'b0;
					end
				TXStartBit:
					Txd<=1'b0;
				TXDataBit:
					begin
						Txd<=TxdBufTmp[BitCnt];
						BitCnt<=BitCnt+1'b1;		
					end
				TXStopBit:
					Txd<=1'b1;
				TXDone:
					TxDone<=1'b1;
				default:
					begin
						BitCnt<=4'b0000;
						Txd<=1'b1;
						TxDone<=1'b0;
					end
			endcase

endmodule